package io.dekorate.kubernetes.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import java.lang.String;
import io.dekorate.deps.kubernetes.api.builder.Predicate;
import java.lang.Deprecated;
import io.dekorate.kubernetes.annotation.ServiceType;
import java.util.Iterator;
import java.lang.Boolean;
import io.dekorate.project.Project;
import io.dekorate.kubernetes.annotation.ImagePullPolicy;
import java.util.Collection;
import java.lang.Object;
import java.util.Map;

public interface KubernetesConfigFluent<A extends KubernetesConfigFluent<A>> extends BaseConfigFluent<A>{


    public A withInitContainers(io.dekorate.kubernetes.config.Container... initContainers);
    
/**
 * This method has been deprecated, please use method buildInitContainers instead.
 */
@Deprecated public io.dekorate.kubernetes.config.Container[] getInitContainers();
    public io.dekorate.kubernetes.config.Container[] buildInitContainers();
    public io.dekorate.kubernetes.config.Container buildInitContainer(int index);
    public io.dekorate.kubernetes.config.Container buildFirstInitContainer();
    public io.dekorate.kubernetes.config.Container buildLastInitContainer();
    public io.dekorate.kubernetes.config.Container buildMatchingInitContainer(io.dekorate.deps.kubernetes.api.builder.Predicate<ContainerBuilder> predicate);
    public Boolean hasMatchingInitContainer(io.dekorate.deps.kubernetes.api.builder.Predicate<ContainerBuilder> predicate);
    public A addToInitContainers(int index,io.dekorate.kubernetes.config.Container item);
    public A setToInitContainers(int index,io.dekorate.kubernetes.config.Container item);
    public A addToInitContainers(io.dekorate.kubernetes.config.Container... items);
    public A addAllToInitContainers(Collection<io.dekorate.kubernetes.config.Container> items);
    public A removeFromInitContainers(io.dekorate.kubernetes.config.Container... items);
    public A removeAllFromInitContainers(Collection<io.dekorate.kubernetes.config.Container> items);
    public A removeMatchingFromInitContainers(io.dekorate.deps.kubernetes.api.builder.Predicate<ContainerBuilder> predicate);
    public Boolean hasInitContainers();
    public KubernetesConfigFluent.InitContainersNested<A> addNewInitContainer();
    public KubernetesConfigFluent.InitContainersNested<A> addNewInitContainerLike(io.dekorate.kubernetes.config.Container item);
    public KubernetesConfigFluent.InitContainersNested<A> setNewInitContainerLike(int index,io.dekorate.kubernetes.config.Container item);
    public KubernetesConfigFluent.InitContainersNested<A> editInitContainer(int index);
    public KubernetesConfigFluent.InitContainersNested<A> editFirstInitContainer();
    public KubernetesConfigFluent.InitContainersNested<A> editLastInitContainer();
    public KubernetesConfigFluent.InitContainersNested<A> editMatchingInitContainer(io.dekorate.deps.kubernetes.api.builder.Predicate<ContainerBuilder> predicate);
    public int getReplicas();
    public A withReplicas(int replicas);
    public Boolean hasReplicas();
    public boolean isHeadless();
    public A withHeadless(boolean headless);
    public Boolean hasHeadless();

    public interface InitContainersNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,ContainerFluent<KubernetesConfigFluent.InitContainersNested<N>>{

        
    public N and();    public N endInitContainer();
}


}
